/* Created with BaCon 4.1.1 - (c) Peter van Eerten - MIT License */
#include "pup_event_ipc.bac.h"
#include "pup_event_ipc.bac.string.h"
#include "pup_event_ipc.bac.float.h"
/****************************/
/* Main program starts here */
/****************************/
int
main (int argc, char **argv)
{
  setvbuf (stdout, NULL, _IOLBF, 0);
  if (argc > 0)
    {
      __b2c__me_var__b2c__string_var = strdup (argv[0]);
    }
  if (argc == 2 && !strcmp (argv[1], "-bacon"))
    {
      fprintf (stderr, "Converted by %s.\n",
	       COMPILED_BY_WHICH_BACON__b2c__string_var);
      exit (EXIT_FAILURE);
    }
/* Setup the reserved variable 'ARGUMENT' */
  for (__b2c__counter = 0; __b2c__counter < argc; __b2c__counter++)
    {
      if (strstr (argv[__b2c__counter], " ")
	  || strstr (argv[__b2c__counter], "\011"))
	__b2c__arglen += strlen (argv[__b2c__counter]) + 3;
      else
	__b2c__arglen += strlen (argv[__b2c__counter]) + 1;
    }
  __b2c__arglen++;
  ARGUMENT__b2c__string_var = (char *) calloc (__b2c__arglen, sizeof (char));
  for (__b2c__counter = 0; __b2c__counter < argc; __b2c__counter++)
    {
      if (strstr (argv[__b2c__counter], " ")
	  || strstr (argv[__b2c__counter], "\011"))
	{
	  strcat (ARGUMENT__b2c__string_var, "\042");
	  strcat (ARGUMENT__b2c__string_var, argv[__b2c__counter]);
	  strcat (ARGUMENT__b2c__string_var, "\042");
	}
      else
	strcat (ARGUMENT__b2c__string_var, argv[__b2c__counter]);
      if (__b2c__counter != argc - 1)
	strcat (ARGUMENT__b2c__string_var, " ");
    }
/* By default seed random generator */
  srandom ((unsigned int) time (NULL));
/* Initialize internal stackpointer */
  __b2c__typestack = (int *) calloc (1, sizeof (int));
  __b2c__stringstack =
    (char **) realloc (__b2c__stringstack, sizeof (char *));
  __b2c__stringstack[0] = (char *) calloc (1, sizeof (char));
/* Determine current moment and keep it for timer function */
  gettimeofday (&__b2c__tm, NULL);
  __b2c__elapsed_usecs = __b2c__tm.tv_usec;
  __b2c__elapsed_secs = __b2c__tm.tv_sec;
/* Setup error signal handling */
  signal (SIGILL, __b2c__catch_signal);
  signal (SIGABRT, __b2c__catch_signal);
  signal (SIGFPE, __b2c__catch_signal);
  signal (SIGSEGV, __b2c__catch_signal);
/* Rest of the program */
#line 15 "pup_event_ipc.bac"
  helpflg = 0;
  milliseconds = 0;
#line 18 "pup_event_ipc.bac"
  helpflg = (int) (0);
#line 19 "pup_event_ipc.bac"
  milliseconds = (int) (0);
#line 20 "pup_event_ipc.bac"
  sendstr__b2c__string_var =
    __b2c_Assign_String (&sendstr__b2c__string_var, "");
#line 21 "pup_event_ipc.bac"
  if ((argc) == 1)
    {
      helpflg = (int) (1);
    }
#line 22 "pup_event_ipc.bac"
  for (x = 1; x <= argc - 1; x += 1)
    {
#line 23 "pup_event_ipc.bac"
      __b2c__STRFREE (arg__b2c__string_var);
      arg__b2c__string_var =
	__b2c__strdup ((const char *) argv[(uint64_t) x]);
#line 24 "pup_event_ipc.bac"
      if (__b2c__STRCMP (arg__b2c__string_var, "--help") == 0)
	{
#line 25 "pup_event_ipc.bac"
	  helpflg = (int) (1);
#line 26 "pup_event_ipc.bac"
	  continue;
#line 27 "pup_event_ipc.bac"
	}
#line 28 "pup_event_ipc.bac"
      if (__b2c__STRCMP (arg__b2c__string_var, "-h") == 0)
	{
#line 29 "pup_event_ipc.bac"
	  helpflg = (int) (1);
#line 30 "pup_event_ipc.bac"
	  continue;
#line 31 "pup_event_ipc.bac"
	}
#line 32 "pup_event_ipc.bac"
      if (__b2c__STRCMP (arg__b2c__string_var, "-t") == 0)
	{
#line 33 "pup_event_ipc.bac"
	  x = x + (1);
#line 34 "pup_event_ipc.bac"
	  milliseconds = (int) (VAL (argv[(uint64_t) x]));
#line 35 "pup_event_ipc.bac"
	  continue;
#line 36 "pup_event_ipc.bac"
	}
#line 37 "pup_event_ipc.bac"
      sendstr__b2c__string_var =
	__b2c_Assign_String (&sendstr__b2c__string_var, arg__b2c__string_var);
#line 38 "pup_event_ipc.bac"
    }
#line 40 "pup_event_ipc.bac"
  if ((helpflg) == 1)
    {
#line 41 "pup_event_ipc.bac"
      __b2c__assign =
	(char *)
	"(c) Copyright Barry Kauler, June 2013, license GPL3 (/usr/share/doc/legal)";
      if (__b2c__assign != NULL)
	{
	  fputs (__b2c__assign, stdout);
	}
      fputs ("\n", stdout);
#line 42 "pup_event_ipc.bac"
      __b2c__assign =
	(char *)
	"This is a CLI utility that may be used in scripts. Run like this:";
      if (__b2c__assign != NULL)
	{
	  fputs (__b2c__assign, stdout);
	}
      fputs ("\n", stdout);
#line 43 "pup_event_ipc.bac"
      __b2c__assign = (char *) " pup_event_ipc \"request:client[:message]\"";
      if (__b2c__assign != NULL)
	{
	  fputs (__b2c__assign, stdout);
	}
      fputs ("\n", stdout);
#line 44 "pup_event_ipc.bac"
      __b2c__assign =
	(char *)
	" request: name of another application to send the message to*. Or,";
      if (__b2c__assign != NULL)
	{
	  fputs (__b2c__assign, stdout);
	}
      fputs ("\n", stdout);
#line 45 "pup_event_ipc.bac"
      __b2c__assign =
	(char *)
	" request: keyword to request information. Supported keywords:";
      if (__b2c__assign != NULL)
	{
	  fputs (__b2c__assign, stdout);
	}
      fputs ("\n", stdout);
#line 46 "pup_event_ipc.bac"
      __b2c__assign = (char *) "          mailbox waitmail";
      if (__b2c__assign != NULL)
	{
	  fputs (__b2c__assign, stdout);
	}
      fputs ("\n", stdout);
#line 47 "pup_event_ipc.bac"
      __b2c__assign =
	(char *)
	"          block dbus network x bluetoothhw timeout1 timeout4 timeout60";
      if (__b2c__assign != NULL)
	{
	  fputs (__b2c__assign, stdout);
	}
      fputs ("\n", stdout);
#line 48 "pup_event_ipc.bac"
      __b2c__assign =
	(char *)
	" client:  any single-word to identify client (usually sender) application*.";
      if (__b2c__assign != NULL)
	{
	  fputs (__b2c__assign, stdout);
	}
      fputs ("\n", stdout);
#line 49 "pup_event_ipc.bac"
      __b2c__assign =
	(char *)
	" message: any text string (that other side understands), up to 4000 bytes.";
      if (__b2c__assign != NULL)
	{
	  fputs (__b2c__assign, stdout);
	}
      fputs ("\n", stdout);
#line 50 "pup_event_ipc.bac"
      __b2c__assign =
	(char *) "          any characters allowed, including \":\"";
      if (__b2c__assign != NULL)
	{
	  fputs (__b2c__assign, stdout);
	}
      fputs ("\n", stdout);
#line 51 "pup_event_ipc.bac"
      __b2c__assign =
	(char *)
	"ex: pup_event_ipc \"otherapp:myapp:some data for otherapp\"";
      if (__b2c__assign != NULL)
	{
	  fputs (__b2c__assign, stdout);
	}
      fputs ("\n", stdout);
#line 52 "pup_event_ipc.bac"
      __b2c__assign =
	(char *)
	"ex: pup_event_ipc \"mailbox:otherapp:some data for otherapp\"";
      if (__b2c__assign != NULL)
	{
	  fputs (__b2c__assign, stdout);
	}
      fputs ("\n", stdout);
#line 53 "pup_event_ipc.bac"
      __b2c__assign = (char *) "ex: pup_event_ipc \"mailbox:myapp\"";
      if (__b2c__assign != NULL)
	{
	  fputs (__b2c__assign, stdout);
	}
      fputs ("\n", stdout);
#line 54 "pup_event_ipc.bac"
      __b2c__assign = (char *) "ex: pup_event_ipc \"waitmail:myapp\"";
      if (__b2c__assign != NULL)
	{
	  fputs (__b2c__assign, stdout);
	}
      fputs ("\n", stdout);
#line 55 "pup_event_ipc.bac"
      __b2c__assign = (char *) "ex: pup_event_ipc \"block:myapp\"";
      if (__b2c__assign != NULL)
	{
	  fputs (__b2c__assign, stdout);
	}
      fputs ("\n", stdout);
#line 56 "pup_event_ipc.bac"
      __b2c__assign =
	(char *) "pup_event_ipc has an optional timeout (milliseconds),";
      if (__b2c__assign != NULL)
	{
	  fputs (__b2c__assign, stdout);
	}
      fputs ("\n", stdout);
#line 57 "pup_event_ipc.bac"
      __b2c__assign =
	(char *) "ex: pup_event_ipc -t 1000 \"otherapp:myapp:data for you\"";
      if (__b2c__assign != NULL)
	{
	  fputs (__b2c__assign, stdout);
	}
      fputs ("\n", stdout);
#line 58 "pup_event_ipc.bac"
      __b2c__assign = (char *) "Will exit with non-zero value if an error:";
      if (__b2c__assign != NULL)
	{
	  fputs (__b2c__assign, stdout);
	}
      fputs ("\n", stdout);
#line 59 "pup_event_ipc.bac"
      __b2c__assign =
	(char *)
	" 1=timeout. 2=wrong msg format. 3-7=message-passing failure. ";
      if (__b2c__assign != NULL)
	{
	  fputs (__b2c__assign, stdout);
	}
      fputs ("\n", stdout);
#line 60 "pup_event_ipc.bac"
      __b2c__assign =
	(char *) "*Any unique names that both clients agree on.";
      if (__b2c__assign != NULL)
	{
	  fputs (__b2c__assign, stdout);
	}
      fputs ("\n", stdout);
#line 61 "pup_event_ipc.bac"
      __b2c__assign =
	(char *)
	"PLEASE SEE /usr/local/pup_event/pup_event_ipc-README.htm for more details.";
      if (__b2c__assign != NULL)
	{
	  fputs (__b2c__assign, stdout);
	}
      fputs ("\n", stdout);
#line 62 "pup_event_ipc.bac"
      exit (0);
#line 63 "pup_event_ipc.bac"
    }
#line 66 "pup_event_ipc.bac"
#line 68 "pup_event_ipc.bac"
#line 70 "pup_event_ipc.bac"
  fd1 = 0;
  len1 = 0;
  leni = 0;
  size_buf = 0;
  thiswatchfile = 0;
  otherwatchfile = 0;
#line 71 "pup_event_ipc.bac"
#line 72 "pup_event_ipc.bac"
  thisdescr = 0;
  otherdescr = 0;
#line 73 "pup_event_ipc.bac"
  size_char = (long) (sizeof (char));
#line 74 "pup_event_ipc.bac"
  size_inbuf = (long) (size_char * 4096);
#line 75 "pup_event_ipc.bac"
  inbuf__b2c_array = size_inbuf;
  inbuf = (char *) calloc ((size_t) size_inbuf + 0, sizeof (char));
  bufinotify__b2c_array = size_inbuf;
  bufinotify = (char *) calloc ((size_t) size_inbuf + 0, sizeof (char));
#line 77 "pup_event_ipc.bac"
#line 86 "pup_event_ipc.bac"
#line 89 "pup_event_ipc.bac"
#line 90 "pup_event_ipc.bac"
#line 91 "pup_event_ipc.bac"
#line 92 "pup_event_ipc.bac"
#line 93 "pup_event_ipc.bac"

#line 95 "pup_event_ipc.bac"
  pfd.events = (short) (POLLIN);
#line 97 "pup_event_ipc.bac"
#line 125 "pup_event_ipc.bac"
  field1__b2c__string_var =
    __b2c_Assign_String (&field1__b2c__string_var, "");
#line 126 "pup_event_ipc.bac"
  field2__b2c__string_var =
    __b2c_Assign_String (&field2__b2c__string_var, "");
#line 127 "pup_event_ipc.bac"
  message__b2c__string_var =
    __b2c_Assign_String (&message__b2c__string_var, "");
#line 128 "pup_event_ipc.bac"
  arr1 = (char *) (sendstr__b2c__string_var);
  __b2c__INVALIDATE (sendstr__b2c__string_var);
#line 129 "pup_event_ipc.bac"
  off1 = (long) (INSTR (arr1, ":"));
#line 130 "pup_event_ipc.bac"
  if ((off1) == 0)
    {
      exitsub (2);
    }
#line 131 "pup_event_ipc.bac"
  arr1[(uint64_t) off1 - 1] = 0;
#line 132 "pup_event_ipc.bac"
  field1__b2c__string_var =
    __b2c_Assign_String (&field1__b2c__string_var, arr1);
#line 133 "pup_event_ipc.bac"
  off2 = (long) (INSTR (arr1 + off1, ":"));
#line 134 "pup_event_ipc.bac"
  arr1[(uint64_t) off1 + off2 - 1] = 0;
#line 135 "pup_event_ipc.bac"
  __b2c__STRFREE (field2__b2c__string_var);
  field2__b2c__string_var = __b2c__strdup ((const char *) arr1 + off1);
#line 136 "pup_event_ipc.bac"
  if ((off2) > 0)
    {
#line 138 "pup_event_ipc.bac"
      __b2c__STRFREE (message__b2c__string_var);
      message__b2c__string_var =
	__b2c__strdup ((const char *) arr1 + off1 + off2);
#line 139 "pup_event_ipc.bac"
    }
#line 141 "pup_event_ipc.bac"
  otherapp = (char *) (0);
#line 142 "pup_event_ipc.bac"
  thisapp = (char *) (0);
#line 143 "pup_event_ipc.bac"
  thiscreateflag = (long) (1);
#line 144 "pup_event_ipc.bac"
  if (__b2c__select_144__b2c__string_var)
    {
      free (__b2c__select_144__b2c__string_var);
    }
  __b2c__select_144__b2c__string_var =
    __b2c__strdup ((const char *) field1__b2c__string_var);
#line 145 "pup_event_ipc.bac"
  if (!__b2c__strcmp (__b2c__select_144__b2c__string_var, "mailbox"))
    {
#line 146 "pup_event_ipc.bac"
      if (__b2c__STRCMP (message__b2c__string_var, "") != 0)
	{
#line 147 "pup_event_ipc.bac"
	  otherapp = (char *) (field2__b2c__string_var);
	  __b2c__INVALIDATE (field2__b2c__string_var);
#line 148 "pup_event_ipc.bac"
	}
      else
	{
#line 149 "pup_event_ipc.bac"
	  thisapp = (char *) (field2__b2c__string_var);
	  __b2c__INVALIDATE (field2__b2c__string_var);
#line 150 "pup_event_ipc.bac"
	}
#line 151 "pup_event_ipc.bac"
    }
  else if (!__b2c__strcmp (__b2c__select_144__b2c__string_var, "waitmail"))
    {
#line 152 "pup_event_ipc.bac"
      thisapp = (char *) (field2__b2c__string_var);
      __b2c__INVALIDATE (field2__b2c__string_var);
#line 153 "pup_event_ipc.bac"
    }
  else if (!__b2c__strcmp (__b2c__select_144__b2c__string_var, "block"))
    {
#line 155 "pup_event_ipc.bac"
      thisapp__b2c__string_var =
	__b2c_Assign_String (&thisapp__b2c__string_var,
			     CONCAT__b2c__string_var ("block_",
						      field2__b2c__string_var));
#line 156 "pup_event_ipc.bac"
      thisapp = (char *) (thisapp__b2c__string_var);
      __b2c__INVALIDATE (thisapp__b2c__string_var);
#line 157 "pup_event_ipc.bac"
    }
  else if (!__b2c__strcmp (__b2c__select_144__b2c__string_var, "network"))
    {
#line 159 "pup_event_ipc.bac"
      thisapp__b2c__string_var =
	__b2c_Assign_String (&thisapp__b2c__string_var,
			     CONCAT__b2c__string_var ("network_",
						      field2__b2c__string_var));
#line 160 "pup_event_ipc.bac"
      thisapp = (char *) (thisapp__b2c__string_var);
      __b2c__INVALIDATE (thisapp__b2c__string_var);
#line 161 "pup_event_ipc.bac"
    }
  else if (!__b2c__strcmp (__b2c__select_144__b2c__string_var, "x"))
    {
#line 163 "pup_event_ipc.bac"
      thisapp__b2c__string_var =
	__b2c_Assign_String (&thisapp__b2c__string_var,
			     CONCAT__b2c__string_var ("x_",
						      field2__b2c__string_var));
#line 164 "pup_event_ipc.bac"
      thisapp = (char *) (thisapp__b2c__string_var);
      __b2c__INVALIDATE (thisapp__b2c__string_var);
#line 165 "pup_event_ipc.bac"
    }
  else if (!__b2c__strcmp (__b2c__select_144__b2c__string_var, "timeout1"))
    {
#line 167 "pup_event_ipc.bac"
      thisapp__b2c__string_var =
	__b2c_Assign_String (&thisapp__b2c__string_var,
			     CONCAT__b2c__string_var ("timeout1_",
						      field2__b2c__string_var));
#line 168 "pup_event_ipc.bac"
      thisapp = (char *) (thisapp__b2c__string_var);
      __b2c__INVALIDATE (thisapp__b2c__string_var);
#line 169 "pup_event_ipc.bac"
    }
  else if (!__b2c__strcmp (__b2c__select_144__b2c__string_var, "timeout4"))
    {
#line 171 "pup_event_ipc.bac"
      thisapp__b2c__string_var =
	__b2c_Assign_String (&thisapp__b2c__string_var,
			     CONCAT__b2c__string_var ("timeout4_",
						      field2__b2c__string_var));
#line 172 "pup_event_ipc.bac"
      thisapp = (char *) (thisapp__b2c__string_var);
      __b2c__INVALIDATE (thisapp__b2c__string_var);
#line 173 "pup_event_ipc.bac"
    }
  else if (!__b2c__strcmp (__b2c__select_144__b2c__string_var, "timeout60"))
    {
#line 175 "pup_event_ipc.bac"
      thisapp__b2c__string_var =
	__b2c_Assign_String (&thisapp__b2c__string_var,
			     CONCAT__b2c__string_var ("timeout60_",
						      field2__b2c__string_var));
#line 176 "pup_event_ipc.bac"
      thisapp = (char *) (thisapp__b2c__string_var);
      __b2c__INVALIDATE (thisapp__b2c__string_var);
#line 177 "pup_event_ipc.bac"
    }
  else if (!__b2c__strcmp (__b2c__select_144__b2c__string_var, "bluetoothhw"))
    {
#line 180 "pup_event_ipc.bac"
      thisapp__b2c__string_var =
	__b2c_Assign_String (&thisapp__b2c__string_var,
			     CONCAT__b2c__string_var ("bluetoothhw_",
						      field2__b2c__string_var));
#line 181 "pup_event_ipc.bac"
      thisapp = (char *) (thisapp__b2c__string_var);
      __b2c__INVALIDATE (thisapp__b2c__string_var);
#line 182 "pup_event_ipc.bac"
    }
  else if (!__b2c__strcmp (__b2c__select_144__b2c__string_var, "dbus"))
    {
#line 185 "pup_event_ipc.bac"
      thisapp__b2c__string_var =
	__b2c_Assign_String (&thisapp__b2c__string_var,
			     CONCAT__b2c__string_var ("dbus_",
						      field2__b2c__string_var));
#line 186 "pup_event_ipc.bac"
      thisapp = (char *) (thisapp__b2c__string_var);
      __b2c__INVALIDATE (thisapp__b2c__string_var);
#line 187 "pup_event_ipc.bac"
    }
  else
    {
#line 188 "pup_event_ipc.bac"
      otherapp = (char *) (field1__b2c__string_var);
      __b2c__INVALIDATE (field1__b2c__string_var);
#line 189 "pup_event_ipc.bac"
      thisapp = (char *) (field2__b2c__string_var);
      __b2c__INVALIDATE (field2__b2c__string_var);
#line 190 "pup_event_ipc.bac"
    }
#line 193 "pup_event_ipc.bac"
  otherdescr = (int) (0);
#line 194 "pup_event_ipc.bac"
  thisdescr = (int) (0);
#line 195 "pup_event_ipc.bac"
  watchdir = (long) (0);
#line 196 "pup_event_ipc.bac"
  if ((FILEEXISTS ("/tmp/pup_event_ipc")) == 0)
    {
      __b2c__assign = __b2c__strdup ("/tmp/pup_event_ipc");
      if (__b2c__assign != NULL && *__b2c__assign != 0)
	{
	  if (*__b2c__assign != '/')
	    {
	      __b2c__ctr = __b2c__len (__b2c__assign);
	      __b2c__assign =
		(char *) realloc (__b2c__assign, __b2c__ctr + 3);
	      memmove (__b2c__assign + 2, __b2c__assign, __b2c__ctr + 1);
	      __b2c__assign[0] = 46;
	      __b2c__assign[1] = 47;
	    }
	  __b2c__cptr = __b2c__assign;
	  do
	    {
	      __b2c__cptr++;
	      while (*__b2c__cptr != '/' && *__b2c__cptr != '\0')
		__b2c__cptr++;
	      if (*__b2c__cptr == '/')
		{
		  *__b2c__cptr = '\0';
		  mkdir (__b2c__assign,
			 S_IRWXU | S_IRGRP | S_IXGRP | S_IROTH | S_IXOTH);
		  *__b2c__cptr = '/';
		}
	      else if (*__b2c__cptr == '\0')
		{
		  mkdir (__b2c__assign,
			 S_IRWXU | S_IRGRP | S_IXGRP | S_IROTH | S_IXOTH);
		}
	      if (errno != EEXIST && errno != 0)
		{
		  if (__b2c__trap)
		    {
		      ERROR = 21;
		      if (!__b2c__catch_set)
			RUNTIMEERROR ("MAKEDIR", 196, "pup_event_ipc.bac",
				      ERROR);
		      else if (!setjmp (__b2c__jump))
			goto __B2C__PROGRAM__EXIT;
		    }
		}
	    }
	  while (*__b2c__cptr != '\0');
	  free (__b2c__assign);
	}
    }
#line 197 "pup_event_ipc.bac"
  if ((otherapp) != 0)
    {
#line 198 "pup_event_ipc.bac"
      otherfile__b2c__string_var =
	__b2c_Assign_String (&otherfile__b2c__string_var,
			     CONCAT__b2c__string_var ("/tmp/pup_event_ipc/",
						      otherapp));
#line 199 "pup_event_ipc.bac"
#line 200 "pup_event_ipc.bac"
#line 201 "pup_event_ipc.bac"
#line 202 "pup_event_ipc.bac"
#line 203 "pup_event_ipc.bac"
#line 205 "pup_event_ipc.bac"
      __b2c__option_open = (O_WRONLY | O_CREAT | O_APPEND);
#line 206 "pup_event_ipc.bac"
      otherdescr =
	open (otherfile__b2c__string_var, __b2c__option_open,
	      S_IRUSR | S_IWUSR);
      if (otherdescr < 0)
	{
	  if (__b2c__trap)
	    {
	      ERROR = 32;
	      if (!__b2c__catch_set)
		RUNTIMEERROR ("OPEN FOR DEVICE", 206, "pup_event_ipc.bac",
			      ERROR);
	      else if (!setjmp (__b2c__jump))
		goto __B2C__PROGRAM__EXIT;
	    }
	}
#line 208 "pup_event_ipc.bac"
      if (otherdescr <= 0)
	{
	  exitsub (3);
	}
#line 209 "pup_event_ipc.bac"
    }
#line 210 "pup_event_ipc.bac"
  if ((thisapp) != 0)
    {
#line 211 "pup_event_ipc.bac"
      closedflag = (long) (0);
#line 212 "pup_event_ipc.bac"
      thisfile__b2c__string_var =
	__b2c_Assign_String (&thisfile__b2c__string_var,
			     CONCAT__b2c__string_var ("/tmp/pup_event_ipc/",
						      thisapp));
#line 213 "pup_event_ipc.bac"
      if ((thiscreateflag) == 1)
	{
#line 214 "pup_event_ipc.bac"
#line 215 "pup_event_ipc.bac"
#line 216 "pup_event_ipc.bac"
#line 218 "pup_event_ipc.bac"
	  __b2c__option_open = (O_RDWR | O_CREAT);
#line 219 "pup_event_ipc.bac"
	  thisdescr =
	    open (thisfile__b2c__string_var, __b2c__option_open,
		  S_IRUSR | S_IWUSR);
	  if (thisdescr < 0)
	    {
	      if (__b2c__trap)
		{
		  ERROR = 32;
		  if (!__b2c__catch_set)
		    RUNTIMEERROR ("OPEN FOR DEVICE", 219, "pup_event_ipc.bac",
				  ERROR);
		  else if (!setjmp (__b2c__jump))
		    goto __B2C__PROGRAM__EXIT;
		}
	    }
#line 221 "pup_event_ipc.bac"
	}
      else
	{
#line 222 "pup_event_ipc.bac"
	  if ((FILEEXISTS (thisfile__b2c__string_var)) == 1)
	    {
#line 223 "pup_event_ipc.bac"
#line 224 "pup_event_ipc.bac"
#line 225 "pup_event_ipc.bac"
#line 227 "pup_event_ipc.bac"
	      __b2c__option_open = (O_RDWR);
#line 228 "pup_event_ipc.bac"
	      thisdescr =
		open (thisfile__b2c__string_var, __b2c__option_open,
		      S_IRUSR | S_IWUSR);
	      if (thisdescr < 0)
		{
		  if (__b2c__trap)
		    {
		      ERROR = 32;
		      if (!__b2c__catch_set)
			RUNTIMEERROR ("OPEN FOR DEVICE", 228,
				      "pup_event_ipc.bac", ERROR);
		      else if (!setjmp (__b2c__jump))
			goto __B2C__PROGRAM__EXIT;
		    }
		}
#line 230 "pup_event_ipc.bac"
	    }
	  else
	    {
#line 231 "pup_event_ipc.bac"
	      closedflag = (long) (1);
#line 232 "pup_event_ipc.bac"
	    }
#line 233 "pup_event_ipc.bac"
	}
#line 234 "pup_event_ipc.bac"
      if ((closedflag) == 0)
	{
#line 235 "pup_event_ipc.bac"
	  if (thisdescr <= 0)
	    {
	      exitsub (4);
	    }
#line 236 "pup_event_ipc.bac"
	  fd1 = (int) (inotify_init ());
#line 237 "pup_event_ipc.bac"
	  if (fd1 <= 0)
	    {
	      exitsub (5);
	    }
#line 239 "pup_event_ipc.bac"
	  watchdir =
	    (long) (inotify_add_watch
		    (fd1, thisfile__b2c__string_var, IN_MODIFY));
#line 240 "pup_event_ipc.bac"
	  if (watchdir <= 0)
	    {
	      exitsub (6);
	    }
#line 241 "pup_event_ipc.bac"
	}
#line 242 "pup_event_ipc.bac"
    }
#line 245 "pup_event_ipc.bac"
  if (__b2c__select_245__b2c__string_var)
    {
      free (__b2c__select_245__b2c__string_var);
    }
  __b2c__select_245__b2c__string_var =
    __b2c__strdup ((const char *) field1__b2c__string_var);
#line 246 "pup_event_ipc.bac"
  if (!__b2c__strcmp (__b2c__select_245__b2c__string_var, "mailbox"))
    {
#line 247 "pup_event_ipc.bac"
      if ((otherapp) != 0)
	{
#line 249 "pup_event_ipc.bac"
	  outstr__b2c__string_var =
	    __b2c_Assign_String (&outstr__b2c__string_var,
				 CONCAT__b2c__string_var
				 (message__b2c__string_var, "\n"));
#line 252 "pup_event_ipc.bac"
	  wr =
	    (long) (write
		    (otherdescr, outstr__b2c__string_var,
		     strlen (outstr__b2c__string_var)));
#line 253 "pup_event_ipc.bac"
	  __b2c__assign = (char *) "Mailbox acknowledge";
	  if (__b2c__assign != NULL)
	    {
	      fputs (__b2c__assign, stdout);
	    }
	  fputs ("\n", stdout);
#line 254 "pup_event_ipc.bac"
	}
      else
	{
#line 256 "pup_event_ipc.bac"
	  offt = (long) (lseek (thisdescr, 0, SEEK_END));
#line 257 "pup_event_ipc.bac"
	  if ((offt) == 0)
	    {
#line 258 "pup_event_ipc.bac"
	      __b2c__assign = (char *) "Mailbox empty";
	      if (__b2c__assign != NULL)
		{
		  fputs (__b2c__assign, stdout);
		}
	      fputs ("\n", stdout);
#line 259 "pup_event_ipc.bac"
	    }
	  else
	    {
#line 260 "pup_event_ipc.bac"
	      offt = (long) (lseek (thisdescr, 0, SEEK_SET));
#line 261 "pup_event_ipc.bac"
	      numr = (long) (read (thisdescr, inbuf, size_inbuf));
#line 262 "pup_event_ipc.bac"
	      ft = (long) (ftruncate (thisdescr, 0));
#line 263 "pup_event_ipc.bac"
	      if ((numr) > 1)
		{
#line 265 "pup_event_ipc.bac"
		  inbuf[(uint64_t) numr - 1] = (char) (0);
#line 266 "pup_event_ipc.bac"
		  __b2c__STRFREE (inbuf__b2c__string_var);
		  inbuf__b2c__string_var =
		    __b2c__strdup ((const char *) inbuf);
#line 267 "pup_event_ipc.bac"
		  __b2c__assign = (char *) inbuf__b2c__string_var;
		  if (__b2c__assign != NULL)
		    {
		      fputs (__b2c__assign, stdout);
		    }
		  fputs ("\n", stdout);
#line 268 "pup_event_ipc.bac"
		}
#line 269 "pup_event_ipc.bac"
	    }
#line 270 "pup_event_ipc.bac"
	}
#line 271 "pup_event_ipc.bac"
    }
  else if (!__b2c__strcmp (__b2c__select_245__b2c__string_var, "waitmail"))
    {
#line 273 "pup_event_ipc.bac"
      waitsub ();
#line 274 "pup_event_ipc.bac"
#line 275 "pup_event_ipc.bac"
#line 276 "pup_event_ipc.bac"
#line 277 "pup_event_ipc.bac"
#line 278 "pup_event_ipc.bac"
#line 279 "pup_event_ipc.bac"
#line 280 "pup_event_ipc.bac"
    }
  else if (!__b2c__strcmp (__b2c__select_245__b2c__string_var, "network")
	   || !__b2c__strcmp (__b2c__select_245__b2c__string_var,
			      "bluetoothhw")
	   || !__b2c__strcmp (__b2c__select_245__b2c__string_var, "x")
	   || !__b2c__strcmp (__b2c__select_245__b2c__string_var, "timeout1")
	   || !__b2c__strcmp (__b2c__select_245__b2c__string_var, "timeout4")
	   || !__b2c__strcmp (__b2c__select_245__b2c__string_var, "timeout60")
	   || !__b2c__strcmp (__b2c__select_245__b2c__string_var, "block"))
    {
#line 282 "pup_event_ipc.bac"
      if ((FILEEXISTS (thisfile__b2c__string_var)) == 0)
	{
#line 283 "pup_event_ipc.bac"
	  __b2c__assign = (char *) "Not implemented";
	  if (__b2c__assign != NULL)
	    {
	      fputs (__b2c__assign, stdout);
	    }
	  fputs ("\n", stdout);
#line 284 "pup_event_ipc.bac"
	}
      else
	{
#line 285 "pup_event_ipc.bac"
	  waitsub ();
#line 286 "pup_event_ipc.bac"
	}
#line 287 "pup_event_ipc.bac"
    }
  else
    {
#line 289 "pup_event_ipc.bac"
      outstr__b2c__string_var =
	__b2c_Assign_String (&outstr__b2c__string_var,
			     CONCAT__b2c__string_var
			     (message__b2c__string_var, "\n"));
#line 290 "pup_event_ipc.bac"
      wr =
	(long) (write
		(otherdescr, outstr__b2c__string_var,
		 strlen (outstr__b2c__string_var)));
#line 291 "pup_event_ipc.bac"
      waitsub ();
#line 292 "pup_event_ipc.bac"
    }
#line 294 "pup_event_ipc.bac"
  exitsub (0);
__B2C__PROGRAM__EXIT:
  return 0;
}
